<?php
	$tablesql['bans'] = "CREATE TABLE {$CONFIG['tablePrefix']}bans (
						  ID int(11) NOT NULL auto_increment,
						  banned_by varchar(255) NOT NULL default '0',
						  ban_type enum('username','ip') NOT NULL default 'username',
						  ban_from enum('room','login') NOT NULL default 'room',
						  username varchar(255) NOT NULL default '',
						  room_id int(11) NOT NULL default '0',
						  ip varchar(255) NOT NULL default '',
						  ban_start_at int(14) default NULL,
						  PRIMARY KEY  (ID),
						  KEY ban_start_at (ban_start_at)
						) TYPE=MyISAM;";
						
	$tablesql['chat_messages'] = "CREATE TABLE {$CONFIG['tablePrefix']}chat_messages (
								  ID int(11) NOT NULL auto_increment,
								  room int(11) NOT NULL default '0',
								  from_user varchar(255) NOT NULL default '',
								  to_user varchar(255) NOT NULL default '',
								  message text NOT NULL,
								  type tinyint(1) NOT NULL default '0',
								  datetime datetime NOT NULL default '0000-00-00 00:00:00',
								  PRIMARY KEY  (ID),
								  KEY room (room),
								  KEY to_user (to_user)
								) TYPE=MyISAM;";
								
	$tablesql['groups'] = "CREATE TABLE {$CONFIG['tablePrefix']}groups (
							  ID int(11) NOT NULL auto_increment,
							  name varchar(30) NOT NULL default '0',
							  permanent enum('1','0') NOT NULL default '0',
							  description varchar(255) NOT NULL default '0',
							  created date NOT NULL default '0000-00-00',
							  defaultroom tinyint(5) NOT NULL default '0',
							  invisible_priv enum('1','0') NOT NULL default '0',
							  banunban_priv varchar(255) NOT NULL default '',
							  mngusers_priv varchar(255) NOT NULL default '',
							  mnggroups_priv enum('1','0') NOT NULL default '0',
							  mngsystem_priv enum('1','0') NOT NULL default '0',
							  mngrooms_priv enum('1','0') NOT NULL default '0',
							  adminarea_priv enum('1','0') NOT NULL default '0',
							  logintochat_priv enum('1','0') NOT NULL default '1',
							  PRIMARY KEY  (ID)
							) TYPE=MyISAM;";
							
	$tablesql['pvt_rooms_users'] = "CREATE TABLE {$CONFIG['tablePrefix']}pvt_rooms_users (
							  username varchar(255) NOT NULL default '',
							  room_id int(11) NOT NULL default '0'
							) TYPE=MyISAM;";
	
	$tablesql['rooms'] = "CREATE TABLE {$CONFIG['tablePrefix']}rooms (
						  ID int(11) NOT NULL auto_increment,
						  room_name varchar(255) NOT NULL default '',
						  created date NOT NULL default '0000-00-00',
						  room_description varchar(255) NOT NULL default 'No description',
						  room_type varchar(255) NOT NULL default '',
						  permanent enum('1','0') NOT NULL default '0',
						  empty_start int(11) NOT NULL default '0',
						  PRIMARY KEY  (ID),
						  KEY empty_start (empty_start),
						  KEY room_name (room_name)
						) TYPE=MyISAM;";

	$tablesql['sessions'] = "CREATE TABLE {$CONFIG['tablePrefix']}sessions (
							  sesskey varchar(32) NOT NULL default '',
							  expiry int(11) unsigned NOT NULL default '0',
							  value text NOT NULL,
							  username varchar(255) NOT NULL default '0',
							  room int(11) NOT NULL default '0',
							  datetime datetime NOT NULL default '0000-00-00 00:00:00',
							  ismoderator enum('1','0') NOT NULL default '0',
							  isspy enum('1','0') NOT NULL default '1',
							  status tinyint(4) NOT NULL default '1',
							  ip varchar(16) default NULL,
							  PRIMARY KEY  (sesskey),
							  UNIQUE KEY username (username)
							) TYPE=MyISAM;";
							
	$tablesql['system'] = "CREATE TABLE {$CONFIG['tablePrefix']}system (
							  status enum('1','0') NOT NULL default '0',
							  PRIMARY KEY  (status)
							) TYPE=MyISAM;";

	
	$tablesql['users'] = "CREATE TABLE {$CONFIG['tablePrefix']}users (
						  ID int(11) NOT NULL auto_increment,
						  name varchar(255) NOT NULL default '0',
						  username varchar(255) NOT NULL default '0',
						  password varchar(255) NOT NULL default '0',
						  groupid tinyint(5) NOT NULL default '0',
						  enable enum('1','0') NOT NULL default '1',
						  PRIMARY KEY  (ID),
						  UNIQUE KEY username (username)
						) TYPE=MyISAM;";
						
	$initialdata['groups'] = "INSERT INTO {$CONFIG['tablePrefix']}groups VALUES (1, 'admin', '1', 'for admin users', '0000-00-00', 1, '0', 'all', 'all', '1', '1', '1', '1', '1');
								INSERT INTO {$CONFIG['tablePrefix']}groups VALUES (2, 'spy', '1', 'for spies users', '0000-00-00', 1, '1', 'all', 'non', '0', '0', '0', '0', '1');
								INSERT INTO {$CONFIG['tablePrefix']}groups VALUES (3, 'users', '1', 'For registered chat users', '0000-00-00', 1, '0', 'non', 'non', '0', '0', '0', '0', '1');
								INSERT INTO {$CONFIG['tablePrefix']}groups VALUES (4, 'guests', '1', 'For none registered users \(guests\)loading only as a role and no password checked', '0000-00-00', 1, '0', 'non', 'non', '0', '0', '0', '0', '1')";
								
	$initialdata['rooms'] = "INSERT INTO {$CONFIG['tablePrefix']}rooms VALUES (1, 'The Lounge', '0000-00-00', 'No description', 'public', '1', 0);
								INSERT INTO {$CONFIG['tablePrefix']}rooms VALUES (2, 'Current Events', '2004-08-28', 'No description', 'public', '1', 0);
								INSERT INTO {$CONFIG['tablePrefix']}rooms VALUES (3, 'Tech Talk', '2004-07-11', 'No description', 'public', '1', 0);
								INSERT INTO {$CONFIG['tablePrefix']}rooms VALUES (4, 'Hollywood', '2004-01-01', 'No description', 'public', '1', 0)";
	$initialdata['system'] = "INSERT INTO {$CONFIG['tablePrefix']}system VALUES ('1')";
?>
