<?php
class chatService{
	var $CONFIG; //contains config array
	var $DBConnection; //database object
	
	function chatService(){
		$this->methodTable = array(
				"getSettings"=>array(
				"description"=>"Load setting from cookie",
				"access"=>"private",
				"arguments"=>array("arg1")
				),
				"saveSettings"=>array(
				"description"=>"Save settings to cookie",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2")
				),
				"getUiLang"=>array(
				"description"=>"Load UI language from language file",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),				
				"getRightToLeft"=>array(
				"description"=>"Load right-to-left mode",
				"access"=>"remote",
				"arguments"=>array()
				),
				"getTextSettings"=>array(
				"description"=>"Load text settings",
				"access"=>"remote",
				"arguments"=>array()
				),								
				"loginToChat"=>array(
				"description"=>"Do login procedures",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"checkSession"=>array(
				"description"=>"check and sync session between flash side and service side",
				"access"=>"remote",
				"arguments"=>array("arg1,arg2")
				),
				"logOut"=>array(
				"description"=>"do logout procedures and cleanup",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"changeRoom"=>array(
				"description"=>"changing current room and join to another room depending on group privs",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2")
				),
				"getUsers"=>array(
				"description"=>"get users for a specific room",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"getTotalNumOfUsers"=>array(
				"description"=>"get total number of users logged in",
				"access"=>"remote",
				"arguments"=>array()
				),
				"expireRooms"=>array(
				"description"=>"delete empty rooms which created by users after a specific period",
				"access"=>"private",
				"arguments"=>array()
				),
				"expireBannedUsers"=>array(
				"description"=>"remove ban from a user after a specific period",
				"access"=>"private",
				"arguments"=>array()
				),
				"getRooms"=>array(
				"description"=>"get list of rooms",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"getRoomMessages"=>array(
				"description"=>"get messages sent by users to current room",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3")
				),
				"loadRoomMessage"=>array(
				"description"=>"send a message to current room",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3")
				),
				"formatingInputs"=>array(
				"description"=>"do some text formating for a message sent by a user",
				"access"=>"private",
				"arguments"=>array("arg1","arg2","arg3")
				),
				"getPrivateMessages"=>array(
				"description"=>"get private messages for current user",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"loadPrivateMessages"=>array(
				"description"=>"send a message for a specific user",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3")
				),
				"addRoom"=>array(
				"description"=>"add public or private room",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3")
				),
				"changeUserStatus"=>array(
				"description"=>"changing user status",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2")
				),
				"getPrivateUsersStatus"=>array(
				"description"=>"get a user status for all private conversations",
				"access"=>"remote",
				"arguments"=>array("arg1")
				),
				"sendInvitation"=>array(
				"description"=>"sending invitation to a user to join a room",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3","arg4")
				),
				"ban"=>array(
				"description"=>"ban a user",
				"access"=>"remote",
				"arguments"=>array("arg1","arg2","arg3","arg4")
				),
				"isBanned"=>array(
				"description"=>"check if user banned",
				"access"=>"private",
				"arguments"=>array("arg1","arg2")
				)		
		);		
		
		global $CONFIG,$lang;
		$this->CONFIG = $CONFIG;
		$this->lang = $lang;
		
	}
/**********************************************************************************************************\
    Function Name :getSettings(username)
    Purpose:  Load setting from cookie
\**********************************************************************************************************/
	function getSettings($username){
		if($_COOKIE[$username]){
			return unserialize(stripslashes($_COOKIE[$username]));
		}else{
			return false;
		}
	}
/**********************************************************************************************************\
    Function Name :saveSettings(username,volume,wallpaperSettings,soundfx,language,fontSize,fontName,chatFontSize,chatFontName)
    Purpose:  Save settings to cookie
\**********************************************************************************************************/
	function saveSettings($username,$volume,$wallpaperSettings,$soundfx,$language,$fontSize,$fontName,$chatFontSize,$chatFontName,$smallFontSize){
		global $DBconnection;
		$settings['volume'] = $volume;
		$settings['wallpaperSettings'] = $wallpaperSettings;
		$settings['soundfx'] = $soundfx;
		$settings['language'] = $language;
		$settings['fontSize'] = $fontSize;
		$settings['fontName'] = $fontName;
		$settings['chatFontSize'] = $chatFontSize;						
		$settings['chatFontName'] = $chatFontName;		
		$settings['smallFontSize'] = $smallFontSize;
	    $p = fopen("test.txt",'w');
		$t = "smallFontSize".$smallFontSize;
		fwrite($p,$t,strlen($t));
		fclose($p);
		return setcookie($username,serialize($settings),time()+60*60*24*30);
	}
/**********************************************************************************************************\
    Function Name :getUiLang($l)
    Purpose:  Load UI language from language file
\**********************************************************************************************************/
	function getUiLang($l = null){
	 $lan = ($l) ? $l : $this->CONFIG['defaultLang'];	
       if (file_exists("./languages/".$lan.".txt")) {	   
			$langfile = file("./languages/".$lan.".txt");		
		
			for ($i=1;$i<count($langfile);$i++) {
				$hash = split("=>",$langfile[$i]);
				if (count($hash)==3) {
					$this->lang[trim($hash[0])][trim($hash[1])] = trim($hash[2]);
				}
			}
			
			$this->lang["language"]["name"] = $lan;								
	   }
	 return $this->lang;
	}		
/**********************************************************************************************************\
    Function Name :getRightToLeft()
    Purpose:  Load right-to-left mode
\**********************************************************************************************************/
	function getRightToLeft(){
		return $this->CONFIG['rightToLeft'];
	}		
/**********************************************************************************************************\
    Function Name :getRightToLeft()
    Purpose:  Load right-to-left mode
\**********************************************************************************************************/
	function getTextSettings(){
		$result = array();
		$result['chatFontSize'] = $this->CONFIG['chatFontSize'];
		$result['fontSize'] = $this->CONFIG['fontSize'];		
		$result['smallFontSize'] = $this->CONFIG['smallFontSize'];
				
		return $result;
	}		
	
/**********************************************************************************************************\
    Function Name : loginToChat(user,password)
    Purpose:  Do login validation, procedures and loading some config directive to client
\**********************************************************************************************************/
	function loginToChat($user,$password){
		global $DBconnection;
		
		$this->expireBannedUsers();
		$user = trim($user);
		$result = array();
		if($password){
			if($user){
				//check if user login for master admin
				if($user == $this->CONFIG['masterAdminUsername']){
					//master admin check
					if($this->CONFIG['masterAdminLoginToChatPriv']){
						if($password == $this->CONFIG['masterAdminPass']){
							//loadin privileges
							$result['status'] = true;
							$result['banpriv'] = $this->CONFIG['masterAdminBanPriv'];
							//$result['invisible'] = $this->CONFIG['masterAdminInvisiblePriv'];
							$this->CONFIG['masterAdminInvisiblePriv']?$result['invisible'] = 1 : $result['invisible'] = 0;
							$result['defaultRoom'] = $this->CONFIG['defaultRoomID'];
						}else{
							$result['status'] = false;
							$result['description'] = "bad_pass";
						}
					}else{
						$result['status'] = false;
						$result['description'] = "not_allowed";
					}
					//end of master admin check
				}else{
				
					//registered users check
					$userquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}users WHERE username = '$user'");
					if($DBconnection->numRows($userquery)){
						$userrecord = $DBconnection->getFirstRow($userquery);

						if($password == $userrecord['password']){
							//check allow login in user's group
							$group = $DBconnection->getFirstRow("SELECT * FROM {$this->CONFIG['tablePrefix']}groups WHERE ID = {$userrecord['groupid']}" );
					
							if($group['logintochat_priv']){
								$result['status'] = true;
								$result['banpriv'] = $group['banunban_priv'];
								$result['invisible'] = $group['invisible_priv'];
								
								//check if default room for group is missing, if it is user will take default room in config file 
								if($group['defaultroom']){
									$result['defaultRoom'] = $group['defaultroom'];
								}else{
									$result['defaultRoom'] = $this->CONFIG['defaultRoomID'];
								}
								
							}else{
								$result['status'] = false;
								$result['description'] = "not_allowed";
							}
					
						}else{
							//Incorrect password
							$result['status'] = false;
							$result['description'] = "bad_pass";
						}
					}else{
						//user not exist
						$result['status'] = false;
						$result['description'] = "no_user";
					}
				}
				//end of registered users check
				
			}else{
				//nousername entered
				$result['status'] = false;
				$result['description'] = "enter_name";
			}
			
		}else{
			//guests login
			if($user){
				//check if the guest takes a reserved name
				$userquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}users WHERE username = '$user'");
				
				if($user == $this->CONFIG['masterAdminUsername'] || $DBconnection->rowsInResult($userquery)){
					$result['description'] = "already_exist"; 
					$result['status'] = false;
				}else{
					//load guests group privileges as a user role
					$group = $DBconnection->getRecordById("ID",$this->CONFIG['guestsGroupID'],"{$this->CONFIG['tablePrefix']}groups");
						if($group['logintochat_priv']){
							$result['status'] = true;
							$result['banpriv'] = $group['banunban_priv'];
							$result['invisible'] = $group['invisible_priv'];
							//check if default room for group is missing, if it is user will take default room in config file 
							if($group['defaultroom']){
								$result['defaultRoom'] = $group['defaultroom'];
							}else{
								$result['defaultRoom'] = $this->CONFIG['defaultRoomID'];
							}
						}else{
							$result['status'] = false;
							$result['description'] = "register_only"; 
						}
				}
				//end of guest name check
			}else{
				//nousername entered
				$result['status'] = false;
				$result['description'] = "enter_name";
			}
			//end of guests login
		}
		
		//extract banpriv values
		if($result['banpriv'] != "all" && $result['banpriv'] != "non"){
			$result['banpriv'] = explode(",",$result['banpriv']);
		}
		
		//check system status
		if(!$DBconnection->getFieldValue("status","{$this->CONFIG['tablePrefix']}system")){
			$result['status'] = false;
			$result['description'] = "system_down";
		}
		//end of check system status
		
		//check if the maximum number of users exceeded for default room
		if($result['status'] && $this->CONFIG['maximumUsersPerRoom']){
			if(!($this->CONFIG['maximumUsersPerRoom'] > $DBconnection->numRows("SELECT room FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = ".$result['defaultRoom']))){
				$result['status'] = false;
				$result['description'] = "full_room";
			}
		}
		
		//user enabled check
		if($result['status'] && !$userrecord['enable'] && $group['ID'] != $this->CONFIG['guestsGroupID'] && $user != $this->CONFIG['masterAdminUsername']){
			$result['status'] = false;
			$result['description'] = "disabled_account";
		}
		//end of user enabled check
		
		//check ban
		if($result['status'] && $user != $this->CONFIG['masterAdminUsername'] && $group['banunban_priv'] == "non"){
			//check banned from login for all users thet have not ban and unban privilege
			if($this->isBanned("any","login",'',$user)){
				$result['status'] = false;
				$result['description'] = "banned";
			}
			
			//check if user banned from join default room
			//default room for group
			if($this->isBanned("any","room",$result['defaultRoom'],$user)){
				$result['status'] = false;
				$result['description'] = "banned";
			}
		}
		//end of ban check
		
		//login procedures
		$sessId = session_id();
		$userquery = $DBconnection->getRecordById("sesskey",$sessId,"{$this->CONFIG['tablePrefix']}sessions");
		if($result['status']){
			if($userquery['username'] == $user){
				$result['status'] = true;
			}else{
				//register a new user
				//check if the user logged in
				if(!$DBconnection->numRows("SELECT username FROM {$this->CONFIG['tablePrefix']}sessions WHERE username = '$user'")){
					
					if($_SESSION['username']){
						//session resumed
						$_SESSION['username'] = $user;
						$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}sessions SET username = '$user' WHERE sesskey = '$sessId'");
					}
					
					$_SESSION['banpriv'] = $result['banpriv'];
					$_SESSION['username'] = $user;
					$_SESSION['invisible'] = $result['invisible'];
					$result['status'] = true;
				}else{
					//user name exist
					$result['description'] = "already_loggedin";
					$result['status'] = false;
				}
			}
		}
		
		//add config variables and user settings
		if($result['status']){
			$result['updateAfter'] = $this->CONFIG['updateAfter']*1000;//converts from seconds to milliseconds  
			$result['defaultVolume'] = $this->CONFIG['defaultVolume'];
			$result['connectionTimeOut'] = $this->CONFIG['connectionTimeOut'];
			$result['userSettings'] = $this->getSettings($user);
			$result['helpFile'] = $this->CONFIG['helpFile'];
		}
		
		
		//add session id
		$result['sessionID'] = $sessId;
		return $result;
	}
	
/**********************************************************************************************************\
    Function Name :	checkSession(session ID,current room Id,banPriv)
    Purpose:  check and sync session between flash side and service side
\**********************************************************************************************************/
	function checkSession($sessID,$curRoomId,$banPriv){
		global $DBconnection;
		
		//check if user exist in sessions table if not the flash side will do logout action
		$sessquery = $DBconnection->getRecordById("sesskey ",$sessID,"{$this->CONFIG['tablePrefix']}sessions");
		if($sessquery['username']){
			$result['username'] = true;
		}else{
			$result['username'] = false;
		}
		
		//this action occur when room changed by admin area
		//for instance when admin remove a room and move joined users to another room
		if($curRoomId <> $sessquery['room']){
			if($banPriv == "all"){
				$moderator = 1;
			}else if(is_array($banPriv)){
				in_array($sessquery['room'],$banPriv)? $moderator =1 : $moderator = 0;
			}else{
				$moderator = 0;
			}

			$result['roomChanged'] = $this->changeRoom($sessquery['room'],$curRoomId,$sessquery['username']);
			//if failed to change user room because he banned from join this room then 
			//logout user
			if(!$result['roomChanged']['status']){
				$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}sessions WHERE sesskey = '$sessID'");
				$result['username'] = false;
			}
		}else{
			$result['roomChanged'] = false;
		}
		return $result;
	}
/**********************************************************************************************************\
    Function Name :logOut(username)
    Purpose:  do logout procedures and cleanup
\**********************************************************************************************************/
	function logOut($username){
		global $DBconnection,$session;
		//remove user from sessions
		//delete all related messages to this user from chat_messages
		$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE from_user = '$username' OR to_user = '.$username'");
		//delete user from pvt_rooms_users 
		$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}pvt_rooms_users WHERE username = '$username'");
		//igor's addon: delete user from sessions
		$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}sessions WHERE username = '$username'");
		$session->destroy_session();
	}
	
/**********************************************************************************************************\
    Function Name :changeRoom(newroomid,$oldroomid[optional],username)
    Purpose:  changing current room and join to another room depending on group privs
\**********************************************************************************************************/
	function changeRoom($newroomid,$oldroomid='',$username){
		global $DBconnection;
		
		$this->expireBannedUsers();
		$newroom = $DBconnection->getValue("SELECT * FROM {$this->CONFIG['tablePrefix']}rooms WHERE ID = $newroomid");
		//check if new room expired
		if(!$newroom){
			$result['title'] = "expired_title";
			$result['changeTo'] = $newroom['room_name'];
			$result['description'] = "expired_desc";
			$result['status'] = false;
			return $result;
		}
		
		if($_SESSION['banpriv'] == "all"){
			$moderator = 1;
		}else if(is_array($_SESSION['banpriv'])){
			in_array($newroomid,$_SESSION['banpriv'])?$moderator = 1 : $moderator = 0;
		}else{
			$moderator = 0;
		}
		//
		
		if(!$moderator){
			$is_banned = $this->isBanned('any','room',$newroomid,$username);
		}
		
		//user is banned to join this room
		if($is_banned){
			$result['title'] = "ban_title";
			$result['changeTo'] = $newroom['room_name'];
			$result['description'] = "ban_desc";
			$result['status'] = false;
			return $result;
		}
		
		
		//if maximum number of users per room exceeded
		if($this->CONFIG['maximumUsersPerRoom']){
			$numousers = $DBconnection->numRows("SELECT room FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = $newroomid");
			if(!($this->CONFIG['maximumUsersPerRoom']>$numousers)){
				$result['title'] = "maximum_title";
				$result['changeTo'] = $newroom['room_name'];
				$result['description'] = "maximum_desc";
				$result['status'] = false;
				
				return $result;
			}
		}
		
		
		if(!$is_banned && $newroomid){
			
			$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}sessions SET room = '$newroomid', ismoderator = '$moderator' WHERE username = '$username'");
			//delete all messages related to this user in old room
			$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE room = '$oldroomid' AND from_user = '$username' AND to_user = 'all'");
			
			$joinTime = date($this->CONFIG['joinRoomTimeStamp'],time());
			//hide change room announcement for spies
			if(!$_SESSION['invisible']){				
//				$loginmsg = "<b>[".$newroom['room_name']."]:</b> $username has entered at $joinTime|".$username;
				$loginmsg = "<b>[".$newroom['room_name']."]:</b> $username %#%entered%#% $joinTime|".$username;				
				$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}chat_messages VALUES(null, '$newroomid', '$username', 'all', '$loginmsg', 2, NOW())");
				$result["maxid"] = mysql_insert_id($DBconnection->connection);
			}else{
				$maxid = $DBconnection->getFirstRow("SELECT MAX(ID) FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE  room = '$newroomid'");
				
				if($maxid['MAX(ID)']){
					$result["maxid"] = $maxid['MAX(ID)'];
				}else{
					$result["maxid"] = 0;
				}
			}
//			$result["msg"] = "Welcome to ".$newroom['room_name'].", you have entered at $joinTime";
			$result["time"] = $joinTime;
			$result["room"] = $newroom['room_name'];
			$result["roomid"] = $newroomid;
			
			//get num of users per room
			$num_of_users = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = '$newroomid'");
			$result["num_of_users"] = $DBconnection->rowsInResult($num_of_users);
			
			//makes some room maintenance
			//if the old room is not permanent and is empty log empty start time to empty_start field
			$room = $DBconnection->getRecordById("ID",$oldroomid,"{$this->CONFIG['tablePrefix']}rooms");
			if(!$room['permanent']){
				$query = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = '$oldroomid'");
				if(!$DBconnection->rowsInResult($query)){
					$time = time();
					$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}rooms SET  empty_start = '$time' WHERE ID = '$oldroomid'");
				}
			}
			//puse expire counter for newroom
			if(!$newroom['permanent']){
				$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}rooms SET  empty_start = '0' WHERE ID = '{$newroom['ID']}'");
			}
			//get current loggedin moderators
			$moderatorsquery = $DBconnection->query("SELECT {$this->CONFIG['tablePrefix']}username FROM sessions WHERE room = $newroomid AND ismoderator = '1'");
			if($DBconnection->rowsInResult($moderatorsquery)){
				while($moderator = $DBconnection->nextRow($moderatorsquery)){
					$moderators[] =  $moderator['username'];
				}
			}
			$result['moderators'] = $moderators;
			$result['status'] = true;
			return $result;
		}
	}
/**********************************************************************************************************\
    Function Name :getUsers(roomid)
    Purpose:  get users for a specific room
\**********************************************************************************************************/
	function getUsers($roomid){
		global $DBconnection;
		
		$moderators = array();
		$user = array();
		$usersResult = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = '$roomid' ");
		while($user = $DBconnection->nextRow($usersResult)){
			if($user['username'] && !$user['isspy']){
				$users[] = $user['username'];
				if($user['ismoderator']){
					$moderators[] = $user['username'];
				}
			}else if($user['username'] == $_SESSION['username'] && $user['isspy']) {
				//if cur user is spy
				$users[] = $user['username'];
			}
		}
		//get moderators
		return $result = array("users"=>$users,"moderators"=>$moderators);
	}
/**********************************************************************************************************\
    Function Name :getTotalNumOfUsers
    Purpose:  get total number of users logged in
\**********************************************************************************************************/
	function getTotalNumOfUsers(){
		global $DBconnection;
		$query = $DBconnection->query("SELECT username FROM {$this->CONFIG['tablePrefix']}sessions WHERE username != '' AND isspy = '0'");
		return $DBconnection->rowsInResult($query);
	}
/**********************************************************************************************************\
    Function Name :expireRooms()
    Purpose:  delete empty rooms which created by users after a specific period
\**********************************************************************************************************/
	function expireRooms(){
		global $DBconnection;
		
		$query = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}rooms WHERE permanent = '0'");
		while($room = $DBconnection->nextRow($query)){
			$time = time();
			$duration = $time-$room['empty_start'];
			if($duration > $this->CONFIG['roomExpireAfter'] && $room['empty_start'] != 0){
				$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}rooms WHERE ID = '".$room['ID']."'");
			}
		}
	}
/**********************************************************************************************************\
    Function Name :expireBannedUsers()
    Purpose:  remove ban from a user after a specific period
\**********************************************************************************************************/
	function expireBannedUsers(){
		global $DBconnection;
		
		$curTime = time();
		if($this->CONFIG['unbanAfter']){
			$banquery = $DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}bans WHERE ($curTime - ban_start_at) > {$this->CONFIG['unbanAfter']}");
			//$DBconnection->query("INSERT INTO test VALUES('','$curTime')");
		}
	}
	
/**********************************************************************************************************\
    Function Name :getRooms()
    Purpose:  get list of rooms
\**********************************************************************************************************/
	function getRooms($username){
		global $DBconnection;
		$this->expireRooms();
		$query = $DBconnection->query("SELECT {$this->CONFIG['tablePrefix']}rooms.*
									FROM {$this->CONFIG['tablePrefix']}rooms LEFT JOIN {$this->CONFIG['tablePrefix']}pvt_rooms_users ON {$this->CONFIG['tablePrefix']}rooms.ID = {$this->CONFIG['tablePrefix']}pvt_rooms_users.room_id 
									WHERE {$this->CONFIG['tablePrefix']}rooms.room_type = 'public' 
									OR {$this->CONFIG['tablePrefix']}pvt_rooms_users.username = '$username' ");
		while($room = $DBconnection->nextRow($query)){
			//get num of users per room
			$num_of_users = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}sessions WHERE room = '{$room['ID']}' AND isspy = '0'");
			
			$rooms[] = array('id'=>$room['ID'],
							'room_name'=>$room['room_name'],
							'room_type'=>$room['room_type'],
							'room_description'=>$room['room_description'],
							'num_of_users'=>$DBconnection->rowsInResult($num_of_users));
							
		}
		return $rooms;
	}
/**********************************************************************************************************\
    Function Name : getRoomMessages(lastmsgid,roomid,from username)
    Purpose:  get messages sent by users to current room
\**********************************************************************************************************/
	function getRoomMessages($lastmsgid,$roomid,$from){
		global $DBconnection;
		$messages = array();
		
		$newmsgs = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE to_user = 'all' AND room = '$roomid' AND ID > '$lastmsgid' ");
		while($message = $DBconnection->nextRow($newmsgs)){
			switch($message['type']){
				case 3:
					//announcement
					$messages["announcements"][] = array("msg"=>$message['message'],"id"=>$message['ID']);
				break;
				case 2:
					//user join a room notification
					$notification = explode("|",$message['message']);
					if($notification[1] != $_SESSION['username']){
						$messages["msgs"][] = $notification[0];
					}
				break;
				default:
					//normal message
					$messages["msgs"][] = $message['message'];
				break;
			}
			if($messages["maxid"] < $message['ID']){
				$messages["maxid"] = $message['ID'];
			}
		}
		//if there are no new messages
		if(!$messages["maxid"] && !$messages["msgs"]){
			$messages["maxid"] = $lastmsgid;
			//$messages["msgs"][] = "";
			//$messages["announcements"][] = "";
		}
		return $messages;
	}
/**********************************************************************************************************\
    Function Name :formatingInputs(message)
    Purpose:  convert HTML tags and urls to link
\**********************************************************************************************************/
	function formatingInputs($message){
		
		//callback functions
		function convertHTMLtags($string){
			if(is_array($string)){
				if(!preg_match("/<b>|<\/b>|<u>|<\/u>|<i>|<\/i>/i",$string[0],$matches)){
					return addslashes(htmlentities($string[0],ENT_QUOTES));
				}else{
					return $string[0];
				}
			}
		}
		
		function url2link($matched){
			$matched = preg_replace("/[\r\n]+/","",$matched[0]);
			if(preg_match("/(http:\/\/)|(https:\/\/)|(ftp:\/\/)/i",$matched)){
				$matched="<a href=\"$matched\" target=\"_blank\">".$matched."</a>";
			}else{
				$matched="<a href=\"http://$matched\" target=\"_blank\"><u>".$matched."</u></a>";
			}
			
			return $matched;
		}
		//end of callback functions
		
		$message = preg_replace("/\\\\+/","",$message);
		$message = preg_replace_callback("/<[\w\/\"\'\= #&\r\n;\:\.@$]+>/i",convertHTMLtags,$message);
		//convert url to link
		$message = preg_replace_callback("/\b(((http|ftp|https):\/\/)|(www.))[\w\.\/\-\:\=\?&%\;]+[\s\S]/i",url2link,$message);
		$message = addslashes($message);
		
		return $message;
	}
/**********************************************************************************************************\
    Function Name : loadRoomMessage(message,from username,roomid)
    Purpose:  send a message to current room
\**********************************************************************************************************/
	function loadRoomMessage($message,$from,$roomid){
		global $DBconnection;
		
		$message = $this->formatingInputs($message);		
		$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}chat_messages VALUES(null, '$roomid', '$from', 'all', '$message', 0, NOW())");
		return $message;
	}
/**********************************************************************************************************\
    Function Name :getPrivateMessages(username)
    Purpose:  get private messages for current user
\**********************************************************************************************************/
	function getPrivateMessages($username){
		global $DBconnection;
		
		$pvtmsgs = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE to_user = '$username'");
		while($message = $DBconnection->nextRow($pvtmsgs)){
			switch($message['type']){
				case 1:
					//incoming invitation
					preg_match("/\[[a-zA-Z0-9 ]+\]/i",$message['message'],$matches);
					$toroom = $matches[0];
					$toroom = preg_replace("/[\[\]]/","",$toroom);
					$message['message'] = preg_replace("/\[".$toroom."\]/i","",$message['message']);
					
					preg_match("/\[[a-zA-Z0-9 ]+\]/i",$message['message'],$matches);
					$toroomid = $matches[0];
					$toroomid = preg_replace("/[\[\]]/","",$toroomid);
					$message['message'] = preg_replace("/\[".$toroomid."\]/i","",$message['message']);
					
					$messages[] = array("message"=>$message["message"],"from"=>$message["from_user"],"toroom"=>$toroom,"toroomid"=>$toroomid,"type"=>1);
				break;
				
				default:
					//private message
					$messages[] = array("message"=>$message["message"],"from"=>$message["from_user"],"type"=>0);
				break;
			}
			$ids[] = $message["ID"];
		}
		//delete retrived messages
		if(is_array($ids)){
			foreach($ids as $key=>$id){
				$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}chat_messages WHERE ID = '$id'");
			}
		}
		return $messages;
	}
/**********************************************************************************************************\
    Function Name :loadPrivateMessages(message,from username,to username)
    Purpose:  send a message for a specific user
\**********************************************************************************************************/
	function loadPrivateMessages($message,$from,$touser){
		global $DBconnection;
		$message = $this->formatingInputs($message);
		$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}chat_messages VALUES(null, '0', '$from', '$touser', '$message', 0, NOW())");
		
		return $result = array("message"=>stripslashes($message),"userwin"=>$touser);
	}
/**********************************************************************************************************\
    Function Name :addRoom(roomname,description,type,username,curroomid)
    Purpose:  add public or private room
\**********************************************************************************************************/
	function addRoom($roomname,$description,$type,$username,$curroomid){
		global $DBconnection;
		if(!$description){
			$description ="No description";
		}
		
		$roomname = trim($roomname);
		if($roomname != ""){
			if($type == "private"){
				//private rooms
					//add room to rooms list
					if($DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}rooms VALUES(null,'$roomname',CURDATE(),'$description','$type','0',0)")){
						$roomid = mysql_insert_id($DBconnection->connection);
						//add user for pvt_rooms_users table
						$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}pvt_rooms_users VALUES('$username','$roomid')");
						$result = array('status'=>true,'description'=>$roomname.' created successfully');
					}else{
						$result = array('status'=>false,'description'=>'Failed to create '.$roomname);
					}
			}else{
				//public rooms
				//add room to rooms list
				if($DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}rooms VALUES(null,'$roomname',CURDATE(),'$description','$type','0',0)")){
					$roomid = mysql_insert_id($DBconnection->connection);
					$result = array('status'=>true,'description'=>$roomname.' created successfully');
				}else{
					$result = array('status'=>false,'description'=>'Failed to create '.$roomname);
				}
			}
		}else{
			$result = array('status'=>false,'description'=>'Unacceptable room name');
		}
		//add user to new room
		if($result['status']){
			$result['response'] = $this->changeRoom($roomid,$curroomid,$username);
			
		}
		return $result;
	}
/**********************************************************************************************************\
    Function Name :changeUserStatus(username,status)
    Purpose:  changing user status
\**********************************************************************************************************/
	function changeUserStatus($username,$status){
		global $DBconnection;
		if($DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}sessions SET status = '$status' WHERE username = '$username'")){
			return true;
		}else{
			return false;
		}
		
	}
/**********************************************************************************************************\
    Function Name :getPrivateUsersStatus(pvtusers)
    Purpose:  get a user status for all private conversations
\**********************************************************************************************************/
	function getPrivateUsersStatus($pvtusers){
		global $DBconnection;
		if(is_array($pvtusers)){
			foreach($pvtusers as $key=>$val){
				$result = $DBconnection->getRecordById("username",$val,"{$this->CONFIG['tablePrefix']}sessions");
				$status[] = array('username'=>$val,'status'=>$result['status']);
			}
		}
		return $status;
	}
/**********************************************************************************************************\
    Function Name :sendInvitation(fromuser,to username,to room, message)
    Purpose:  sending invitation to a user to join a room
\**********************************************************************************************************/
	function sendInvitation($from,$touser,$toroom,$message){
		global $DBconnection;
		//add user to pvt_rooms_users 
		//get room id and type
		$room = $DBconnection->getRecordById("ID",$toroom,"{$this->CONFIG['tablePrefix']}rooms");
		if($room['room_type'] == "private"){
			//check if user already added to pvt_rooms_users
			if(!$DBconnection->numRows("SELECT * FROM {$this->CONFIG['tablePrefix']}pvt_rooms_users WHERE  room_id ='".$room['ID']."' AND username ='$touser'")){
				//add user to pvt_rooms_users
				$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}pvt_rooms_users VALUES('$touser','".$room['ID']."')");
			}
		}
		$message = $message."[".$room['room_name']."][".$room['ID']."]";
		$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}chat_messages VALUES(null, '0', '$from', '$touser', '$message', 1, NOW())");
		
	}
/**********************************************************************************************************\
    Function Name :ban(banType,banFrom,roomId[optional],username[optional])
    Purpose:  ban a user
\**********************************************************************************************************/
	function ban($banType,$banFrom,$roomId = false,$username = false){
		global $DBconnection;
		$result = array();
		$user = $DBconnection->getRecordById("username",$username,"{$this->CONFIG['tablePrefix']}sessions");
		switch($banType){
			case "ip":
				$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}bans VALUES('','".$_SESSION['username']."','$banType','$banFrom','','$roomId','".$user['ip']."',".time().")")?$result['ban'] = true : $result['ban'] = false;
				if($banFrom == "login"){
					//logout all users connected from this ip
					$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}sessions WHERE ip = '{$user['ip']}' AND username != '{$_SESSION['username']}'")?$result['action'] = true : $result['action'] = false;
				}else if($banFrom == "room"){
					//change room for all users from this ip if it's a banned room
					$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}sessions SET room = {$this->CONFIG['defaultRoomID']} WHERE room = $roomId AND ip = '".$user['ip']."' AND username != '".$_SESSION['username']."'");
				}
			break;
			
			case "username":
				$DBconnection->query("INSERT INTO {$this->CONFIG['tablePrefix']}bans VALUES('','{$_SESSION['username']}','$banType','$banFrom','$username','$roomId','',".time().")")?$result['ban'] = true : $result['ban'] = false;
				if($banFrom == "login"){
					$DBconnection->query("DELETE FROM {$this->CONFIG['tablePrefix']}sessions WHERE username = '$username'")?$result['action'] = true : $result['action'] = false;
				}else if($banFrom == "room"){
					$DBconnection->query("UPDATE {$this->CONFIG['tablePrefix']}sessions SET room = ".$this->CONFIG['defaultRoomID']." WHERE room = $roomId AND username = '$username' ");
				}
			break;
		}
	}
/**********************************************************************************************************\
    Function Name :isBanned(banType,banFrom,roomIdToCheck[optional],$usernameToCheck[optional])
    Purpose:  check if user banned
\**********************************************************************************************************/
	function isBanned($banType,$banFrom,$roomIdToCheck = false,$usernameToCheck = false){
		global $DBconnection;
		switch($banType){
		
			case "username":
				//check ban by username
				switch($banFrom){
					case "login":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE ban_type = 'username' AND ban_from = 'login' AND username = '$usernameToCheck'");
					break;
					
					case "room":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE ban_type = 'username' AND ban_from = 'room' AND username = '$usernameToCheck' AND room_id = $roomIdToCheck");
					break;
					
					default:
						$banquery = false;
					break;
					
				}
				$DBconnection->rowsInResult($banquery)? $result=true : $result=false;

			break;
			
			case "ip":
				//check ban by ip
				switch($banFrom){
					case "login":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE ban_type = 'ip' AND ban_from = 'login' AND ip = '".$_SERVER['REMOTE_ADDR']."'");
					break;
					
					case "room":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE ban_type = 'ip' AND ban_from = 'room' AND ip = '".$_SERVER['REMOTE_ADDR']."' AND room_id = $roomIdToCheck");
					break;
					
					default:
						$banquery = false;
					break;
				}
				$DBconnection->rowsInResult($banquery)? $result=true : $result=false;

			break;
			
			case "any":
				//check ban username or ip
				switch($banFrom){
					case "login":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE (ban_type = 'ip' AND ip = '".$_SERVER['REMOTE_ADDR']."' AND ban_from = 'login') OR (ban_type = 'username' AND username = '$usernameToCheck' AND ban_from = 'login')");
					break;
					
					case "room":
						$banquery = $DBconnection->query("SELECT * FROM {$this->CONFIG['tablePrefix']}bans WHERE (ban_type = 'ip' AND ip = '".$_SERVER['REMOTE_ADDR']."'  AND room_id = '$roomIdToCheck' AND ban_from = 'room') OR (ban_type = 'username' AND username = '$usernameToCheck' AND room_id = '$roomIdToCheck' AND ban_from = 'room' )");
					break;
					
					default:
						$banquery = false;
					break;
				}
				$DBconnection->rowsInResult($banquery)? $result=true : $result=false;
				
			break;
			
			default:
				$result = false;
			break;
			
		}//end of switch
		
		return $result;
	}
}
?>